using System;
using System.IO;

using System.Runtime.InteropServices;


namespace ICTCLASDemo
{
	[StructLayout(LayoutKind.Explicit)] 
	public struct result_t
	{ 
		[FieldOffset(0)] public int start; 
		[FieldOffset(4)] public int length; 
		[FieldOffset(8)] public int POS_id; 
		[FieldOffset(12)] public int word_ID; //!!!ע⣬ﲻһ12C++뷽ʽ()йأΪʲôunsigned int POS_idأ
	}	/// <summary>
	/// ICTCLASDll ժҪ˵
	/// </summary>
	class ICTCLASDll
	{
		const string path = @"D:\пƹ˾\ICTCLAS3.0\ICTCLASDemoCS\bin\Debug\ICTCLAS30.dll";

		[DllImport(path,CharSet=CharSet.Ansi,EntryPoint="ICTCLAS_Init")]
		public static extern bool ICTCLAS_Init(String sInitDirPath);		

		[DllImport(path,CharSet=CharSet.Ansi,EntryPoint="ICTCLAS_ParagraphProcess")]
		public static extern String ICTCLAS_ParagraphProcess(String sParagraph);

		[DllImport(path,CharSet=CharSet.Ansi,EntryPoint="ICTCLAS_Exit")]
		public static extern bool ICTCLAS_Exit();
	
		[DllImport(path,CharSet=CharSet.Ansi,EntryPoint="ICTCLAS_ImportUserDict")]
		public static extern int ICTCLAS_ImportUserDict(String sFilename);

		[DllImport(path,CharSet=CharSet.Ansi,EntryPoint="ICTCLAS_FileProcess")]
		public static extern bool ICTCLAS_FileProcess(String sSrcFilename,String sDestFilename);
		
		
		[DllImport(path,CharSet=CharSet.Ansi,EntryPoint="ICTCLAS_GetParagraphProcessAWordCount")]
		static extern int ICTCLAS_GetParagraphProcessAWordCount(String sParagraph);
		//ICTCLAS_GetParagraphProcessAWordCount
		[DllImport(path,CharSet=CharSet.Ansi,EntryPoint="ICTCLAS_ParagraphProcessAW")]
		static extern void ICTCLAS_ParagraphProcessAW(String sParagraph, [Out,MarshalAs(UnmanagedType.LPArray)] result_t[] result);
		/// <summary>
		/// Ӧóڵ㡣
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if(!ICTCLAS_Init(null))
			{
				System.Console.WriteLine("Init ICTCLAS failed!");
				return;
			}

			String s ="سŮܹϲбڷǵ֮";
			int count = ICTCLAS_GetParagraphProcessAWordCount(s);


			result_t[] result = new result_t[count];//ڿͻԴ
	
			ICTCLAS_ParagraphProcessAW(s,result);
	
			int i=1;
			foreach(result_t r in result)
			{
				Console.WriteLine("No.{0}:start:{1}, length:{2},POS_ID:{3},Word_ID:{4}\n",i++,r.start,r.length,r.POS_id,r.word_ID);
			}

			String pResult;
			//ֻϻСЭɽףӢ̨
			pResult = ICTCLAS_ParagraphProcess("سŮܹϲбڷǵ֮");
			System.Console.WriteLine("Before Userdict imported:");
			System.Console.WriteLine(pResult);
			

			int nCount=ICTCLAS_ImportUserDict("userdict.txt");//Import Userdict
			System.Console.WriteLine(nCount);
			//printf("%d\n",nCount);

			pResult = ICTCLAS_ParagraphProcess("سŮܹϲбڷǵ֮");
			System.Console.WriteLine("After Userdict imported:");
			System.Console.WriteLine(pResult);



			System.Console.WriteLine("Input Sentence Now!(q to quit)\n");
			String sInput = System.Console.ReadLine();			
			while (sInput.CompareTo("q")!=0)
			{
				pResult = ICTCLAS_ParagraphProcess(sInput);
				System.Console.WriteLine("Resut:");
				System.Console.WriteLine(pResult);
				System.Console.WriteLine("\nInput Sentence Now!(q to quit)\n");
				sInput = System.Console.ReadLine();
			}
			ICTCLAS_FileProcess("Input.txt","Input_result.txt");
			ICTCLAS_Exit();
		}		
	}
}
